theory Interpretation
imports Main
begin

type_synonym var = nat

type_synonym "interpretation" = "var \<Rightarrow> bool"

definition update :: "interpretation \<Rightarrow> var \<Rightarrow> bool \<Rightarrow> interpretation"  
where     "update I x b \<equiv> (\<lambda> y . if x = y then b else (I y))"

lemma update_eq : "x=y \<Longrightarrow> (update I x b) y = b"
unfolding update_def
by auto


lemma update_neq : "x\<noteq>y \<Longrightarrow> update I x b y = I y"
unfolding update_def
by auto
  
(* interpretation from a list l of boolean values for variables 0;1;.. 
  followed by a default value d *)

fun    interpld :: "'a list \<Rightarrow> 'a \<Rightarrow> nat \<Rightarrow> 'a"
where "interpld [] d = (\<lambda> x. d)"
     |"interpld (a # m) d = (\<lambda> x. case x of 
                                     0 \<Rightarrow> a 
                                   | Suc n \<Rightarrow>  interpld m d n )"

definition  interpl where "interpl l = interpld l True"
definition  Ifalse  where "Ifalse  = (\<lambda> x . False)"
definition  Itrue   where "Itrue  = (\<lambda> x . True)"

end